#include "Object.h"

Object::Object(dBodyID b, dGeomID g)
{
	body = b;
	geom = g;

	dGeomSetBody(geom, body);
}

Object::~Object()
{
}

dBodyID Object::getBody()
{
	return body;
}

dGeomID Object::getGeom() {
	return geom;
}

void Object::addToSpace(dSpaceID space)
{
	dSpaceAdd(space, geom);
}

void Object::setPosition(dReal x, dReal y, dReal z)
{
	dBodySetPosition(body, x, y, z);
}

void Object::setRotation(const dMatrix3 R)
{
	dBodySetRotation(body, R);
}

const dReal * Object::getPosition()
{
	return dBodyGetPosition(body);
}

const dReal * Object::getRotation()
{
	return dBodyGetRotation(body);
}

const dReal * Object::getLinearVel()
{
	return dBodyGetLinearVel(body);
}

const dReal * Object::getAngularVel()
{
	return dBodyGetAngularVel(body);
}