#ifndef OBJECT_H
#define OBJECT_H

#ifndef INCLUDE
#include <ode/ode.h>
#include <drawstuff/drawstuff.h>
#include "viewer.h"
#endif

//#ifndef DRAWSTUFF_TEXTURE_PATH
//#define DRAWSTUFF_TEXTURE_PATH "../../ode/drawstuff/textures"
//#endif

#ifdef _MSC_VER
#pragma warning(disable:4244 4305)  // for VC++, no precision loss complaints
#endif

class Object
{
protected:
	dBodyID body;
	dGeomID geom;

public:
	Object(){};
	Object(dBodyID, dGeomID);
	virtual ~Object();
	dBodyID getBody();
	dGeomID getGeom();
	
	void addToSpace(dSpaceID);

	virtual void setPosition(dReal x, dReal y, dReal z);
	virtual void setRotation(const dMatrix3 R);
	virtual const dReal * getPosition();
	virtual const dReal * getRotation();
	virtual const dReal * getLinearVel();
	virtual const dReal * getAngularVel();
	
	virtual void addToViewer(Viewer& v) = 0;
};

#endif