#include "Part.h"


Part::Part(dWorldID world,dReal width,dReal depth, dReal height)
{
	this->width = width;
	this->depth = depth;
	this->height = height;

	body = dBodyCreate(world);
	geom = dCreateBox(0,width,depth,height);
	
/*
	dMass m;
	m.mass = 1;
	dMassSetSphere(&m, 1.0f, radius);
	dMassAdjust(&m, mass);
	dBodySetMass(body, &m);
*/
	dGeomSetBody(geom, body);
}

void Part::addToViewer(Viewer& v)
{
	mesh = v.getSceneManager()->getMesh(this->getPath());
	node = v.getSceneManager()->addAnimatedMeshSceneNode(mesh);
	dGeomSetData(geom, node);
	
	dReal* position = (dReal*)dGeomGetPosition(getGeom());
	node->setPosition(vector3df((irr::f32)position[0], (irr::f32)position[1], (irr::f32)position[2]));
//	node->setScale(vector3df(width / 10, width / 10, width / 10));
//	node->setRotation(vector3df(90, 0, 0));

	node->setMaterialTexture(0, v.getVideoDriver()->getTexture("../../ode/drawstuff/textures/checkered.ppm"));
	node->setMaterialFlag(video::EMF_LIGHTING, false);
	
	v.addObject(this->geom);
}

void Part::setPath(irr::io::path path)
{
	this->pathToMesh = path;
}

irr::io::path Part::getPath()
{
	return this->pathToMesh;
}

void Part::setScale(const core::vector3df& scale)
{
	node = this->node;
	node->setScale(scale);
}

IAnimatedMeshSceneNode* Part::getNode()
{
	return this->node;
}



/*
dReal* Part::getTransformationMatrix()
{
	return this->transformationMatrix;
}

void Part::setTransformationMatrix(dReal* transformationMatrix)
{
	for(int i=0; i<16; i++)
	{
		this->transformationMatrix[i] = transformationMatrix[i];
	}
}
*/