#include "Object.h"
#include <string>
#include <ode/ode.h>
class Part : public Object
{
protected:
	dReal width;
	dReal depth;
	dReal height;
	irr::io::path pathToMesh;
	IAnimatedMesh* mesh;
	IAnimatedMeshSceneNode* node;
	dReal transformationMatrix[4][4];

public:
//	Part(dWorldID world);							
	Part(dWorldID world, dReal width, dReal depth, dReal height);

	dReal getRadius();
	dReal getWidth();
	void setScale(const core::vector3df& scale);

	void setPath(irr::io::path path);
	irr::io::path getPath();
	void draw();
	void addToViewer(Viewer& v);
	IAnimatedMeshSceneNode* getNode();
//	dReal *getTransformationMatrix();
//	void setTransformationMatrix(dReal* transformationMatrix);
};