#ifndef VIEWER_H
#define VIEWER_H

#include <irrlicht.h>
#include <ode/ode.h>
#include <vector>



using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io; 
using namespace gui;
using namespace std;



class Object;

class Viewer {
private:
	IrrlichtDevice* device;
	IVideoDriver* driver;
	ISceneManager* smgr;
	IGUIEnvironment* guienv;
	ICameraSceneNode* cameraFPS,*cameraView;
	
	vector<dGeomID> geoms;

public:
	Viewer::Viewer(int width, int height);
	
	void updateScene();
	void addObject(dGeomID g);
	void setCameraViewParent(ISceneNode* newParent);
	IVideoDriver* getVideoDriver();
	ISceneManager* getSceneManager();
	bool draw();
	int isFont();
	void Viewer::setFont(gui::IGUIFont* font);
	gui::IGUIFont* font;
	void Viewer::setVisibleDebug(IAnimatedMeshSceneNode *eq);
	void setTarget(dReal x,dReal y,dReal z);
	void setRotation(const core::vector3df& rotation);
	const core::vector3df& getRotation();
	dReal target[3];
	
	
	
};

#endif
