#ifndef CAMERA_H
#define CAMERA_H
#include "Object.h"
#include "Robot.h"
#include <string>
#include "main.h"
#include "vbprm.h"

#define camera_h	1.1
#define camera_w	0.5
#define camera_d	0.5

#define Inf 99999

class Robot;
class Vbprm;


class Camera : public Object
{
protected:
	dReal width;
	dReal depth;
	dReal height;
	IAnimatedMesh* mesh;
	IAnimatedMeshSceneNode* node;
	dReal viewAngle[3];
	dReal focusPoint[3];
	dJointID lockJoint;

public:
//	Part(dWorldID world);							
	Camera(dWorldID world, dReal width, dReal depth, dReal height);
	static dReal angleToPoint;
	void addToViewer(Viewer& v);
	void setPosition(Robot *robot,dReal x,dReal y, dReal z);
	void moveToN(dReal *node,Robot *robot);
//	void updatePosition(Viewer *viewer, dReal x,dReal y, dReal z);
	int stepPosition;
	dReal getRadius();
	dReal getWidth();
	dReal *getViewAngle();
	IAnimatedMeshSceneNode* getNode(void);

	void setViewAngle(dReal a[3]);
	int checkCollision();
	
	void setScale(const core::vector3df& scale);

	void setPath(irr::io::path path);
	irr::io::path getPath();
	void draw();
	void setFocusPoint(dReal point[3]);
	dReal getFocusPointAngle(void);
	void createPath(Vbprm *vbprm, int nodeNumber, dReal end[3], int nodeNo,int path[]);
	void attachCameraJoint();
	void lockCameraJoint();
	void releaseCameraJoint();
};
#endif