#include <irrlicht.h>
#include <ode/ode.h>
#include "robot.h"
#include "Viewer.h"
#include "main.h"
#include "vbprm.h"

#include <iostream>
#include <fstream>
#include <string>


#include "pathv1.h"

using namespace std;
using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

static dWorldID world;
static dSpaceID space,staticSpace,robotSpace;
static dSpaceID cameraSpace;
static dJointGroupID contactJointGroup;
static dGeomID ground;

IrrlichtDevice *device;
IVideoDriver* driver;
ISceneManager* smgr;
IGUIEnvironment* guienv;
ICameraSceneNode* cameraNode;
ISceneNode* sphereNode;
ISceneNode* robotNode;

#define GRAVITY -9.81

//#define equipmentX	2
//#define equipmentY	1.8
//#define equipmentZ	0.75
#define equipmentX	0.1
#define equipmentY	0.1
#define equipmentZ	0.1

dReal positionValve[3];
dReal tempPositions[3][3]={{1.6,0.5,1.0},{1.4,0.6,0.8},{1.5,0.4,1.1}};


//dReal positionValve1[2][3] = {{2.0,-0.6,0.9},{2.4,-0.6,0.9}};
//dReal positionValve2[3][3] = {{2.0,0.2,1.75},{2.1,0.2,1.75},{2.2,0.2,1.75}};

static Robot *robot;
//static Camera *camera;
static Part *processEquipment;

static int isCollision;

#ifdef _IRR_WINDOWS_
#pragma comment(lib, "Irrlicht.lib")
#pragma comment(linker, "/subsystem:windows /ENTRY:mainCRTStartup")
#endif

#define valve1h 1.3
#define valve1x 2.0

dReal Camera::angleToPoint = 0;


void fillVbprm(Vbprm *vbprm,Viewer *viewer)
{
	dReal distanceToMove,movement[3],toMoveTo[3];
	dReal distanceToCP[4];

	const dReal *endPos = robot->getEndPos();
	movement[0] = endPos[0]-tempPositions[0][0];
	movement[1] = endPos[1]-tempPositions[0][1];
	movement[2] = endPos[2]-tempPositions[0][2];
	distanceToCP[0] = dLENGTH(movement);
	distanceToMove = distanceToCP[0];
	movement[0] = tempPositions[0][0]-tempPositions[1][0];
	movement[1] = tempPositions[0][1]-tempPositions[1][1];
	movement[2] = tempPositions[0][2]-tempPositions[1][2];
	distanceToCP[1] = dLENGTH(movement);
	distanceToMove += distanceToCP[1];
	movement[0] = tempPositions[1][0]-tempPositions[2][0];
	movement[1] = tempPositions[1][1]-tempPositions[2][1];
	movement[2] = tempPositions[1][2]-tempPositions[2][2];
	distanceToCP[2] = dLENGTH(movement);
	distanceToMove += distanceToCP[2];
	movement[0] = tempPositions[2][0]-positionValve[0];
	movement[1] = tempPositions[2][1]-positionValve[1];
	movement[2] = tempPositions[2][2]-positionValve[2];
	distanceToCP[3] = dLENGTH(movement);
	distanceToMove += distanceToCP[3];
	vbprm->numberOfSteps = distanceToMove/0.02;

	for(int i = 0; i<52*120*60;i++){
		vbprm->G[i].stepCollision = (int*)malloc(vbprm->numberOfSteps*sizeof(int));
		for(int n=0;n<vbprm->numberOfSteps;n++){
			vbprm->G[i].stepCollision[n] = 1;
		}
	}
	toMoveTo[0]=tempPositions[0][0];
	toMoveTo[1]=tempPositions[0][1];
	toMoveTo[2]=tempPositions[0][2];
	for(int n=0;n<vbprm->numberOfSteps;n++){
		if(n>distanceToCP[0]){
			toMoveTo[0]=tempPositions[1][0];
			toMoveTo[1]=tempPositions[1][1];
			toMoveTo[2]=tempPositions[1][2];
		}
		if(n>distanceToCP[1]){
			toMoveTo[0]=tempPositions[2][0];
			toMoveTo[1]=tempPositions[2][1];
			toMoveTo[2]=tempPositions[2][2];
		}
		if(n>distanceToCP[2]){
			toMoveTo[0]=positionValve[0];
			toMoveTo[1]=positionValve[1];
			toMoveTo[2]=positionValve[2];
		}
		robot->simulateMoveToPos(toMoveTo,viewer,camera,vbprm);
		for(int i = 0; i<52*120*60;i++){
			vbprm->setStatus(robot,camera,n,i);
		}
	}


}

void readOperation()
{

	
	char temp;
	char *pos;
	pos = new char[4];
	int axis=0;
	int charno=0;
	ifstream positionFile;
	positionFile.open("posisjon.txt");
	if(positionFile.is_open())
	{
		while(axis<3)
		{
			
			positionFile>>temp;
			
			if(temp!=','){
				pos[charno]=temp;
				charno++;
			}
			else {
				positionValve[axis]=(dReal)atof(pos);
				charno = 0;
				axis++;
				
			}
			
		}
		delete [] pos;
		positionFile.close();
		
	}
	
	

}


/*
This is the main method. We can now use main() on every platform.
*/
void irrlicht_init()
{ /*
	device = createDevice(				
			video::EDT_OPENGL,			
			dimension2d<u32>(640, 480),	
			16,							
			false,						
			false,						
			false,						
			NULL );						
	
	driver = device->getVideoDriver();		
	smgr = device->getSceneManager();		
	guienv = device->getGUIEnvironment();	
	
	device->setWindowCaption(L"Robotsim");	*/
}



void irrlicht_creation()
{
	
//	cameraNode = smgr->addCameraSceneNode( NULL, vector3df(40,50,-100), vector3df(0,25,0) );
	
//	sphereNode = smgr->addCubeSceneNode( 10.0f);
//	robotNode = smgr->addCubeSceneNode(10.0f);
//    IAnimatedMesh* mesh = smgr->getMesh("../mesh/fr_blackBase.3ds");
    
//	blackBaseNode = smgr->addAnimatedMeshSceneNode( mesh );
//	blackBaseNode->setScale(vector3df(10,10,10));

	
//	blackBaseNode->setMaterialFlag( EMF_LIGHTING, false );	
//	node->setMaterialTexture( 0, driver->getTexture("textures/checkered.ppm") );	

}

void irrlicht_render()
{/*
	driver->beginScene( true, true, SColor(255,100,101,140) );	
	smgr->drawAll();											
	guienv->drawAll();											
	driver->endScene();											*/
}

void irrlicht_actualisation()
{/*
    dReal* odePosition = (dReal*)dGeomGetPosition( blackBaseGeom );
    vector3df newIrrlichtPosition;
    newIrrlichtPosition.set( (f32)odePosition[0], (f32)odePosition[1], (f32)odePosition[2] );
    blackBaseNode->setPosition( newIrrlichtPosition );	*/
}

void irrlicht_finalisation()
{/*
	device->drop();	*/
}

void addProcessEquipment(dWorldID world,dReal x,dReal y, dReal z)
{
  dMatrix3 R;
  processEquipment = new Part(world,equipmentX,equipmentY,equipmentZ);
  processEquipment->setPath("../mesh/processequipment.3DS");

  dRFromAxisAndAngle(R,1,0,0,PI/2);
  dBodySetRotation(processEquipment->getBody(),R);
  dRFromAxisAndAngle(R,0,0,1,-PI/2);
  dBodySetRotation(processEquipment->getBody(),R);
  processEquipment->setPosition(x,y,z);
  dBodySetAutoDisableFlag(processEquipment->getBody(),1);
  processEquipment->addToSpace(staticSpace);




}

static void nearCallbackSpace (void *data, dGeomID o1, dGeomID o2)
{
	if(isCollision == 36){
		if( (camera->getGeom() == o1) || (camera->getGeom() == o2)){
				const int N = 5;
				dContact contact[N];
				int n = dCollide(o1,o2,N,&contact[0].geom, sizeof(dContact));
				if (n>0){
					isCollision = n;
					
				}
				
		}
		else isCollision = 0;
	}
}



//function called by dSpaceCollide and dSpaceCollide when two objects are near, and potentially colliding
static void nearCallback (void *data, dGeomID o1, dGeomID o2)
{
	
	
	if(isCollision == 36){
		if( (camera->getGeom() == o1) || (camera->getGeom() == o2)){
				const int N = 5;
				dContact contact[N];
				int n = dCollide(o1,o2,N,&contact[0].geom, sizeof(dContact));
				if (n>0){
					isCollision = n;
					
				}
				
		}
		else isCollision = 0;
	}

	if (dGeomIsSpace (o1) || dGeomIsSpace (o2)) {		//if one of the objects is a space itself then recall function recursively
		dSpaceCollide2 (o1,o2,data,&nearCallback);
		return;
	}
		
	const int N = 30;				//max number of contactpoints between two surfaces
  dContact contact[N];
  int n = dCollide (o1,o2,N,&contact[0].geom,sizeof(dContact));
	if (n > 0) {
    for (int i=0; i<n; i++) {
			contact[i].surface.mode = dContactSlip1 | dContactSlip2 |
	dContactSoftERP | dContactSoftCFM | dContactApprox1;
      contact[i].surface.mu = dInfinity; 
      contact[i].surface.slip1 = 0.01;
      contact[i].surface.slip2 = 0.01;
      contact[i].surface.soft_erp = 0.2; 
      contact[i].surface.soft_cfm = 0.00001;
      dJointID c = dJointCreateContact (world,contactJointGroup,&contact[i]);			//Create and join a contact joint
      dJointAttach (c,
		    dGeomGetBody(contact[i].geom.g1),
		    dGeomGetBody(contact[i].geom.g2));
    }
  }
}

int checkCameraCollision(int collision)
{

	isCollision = 36; //number to check if callback is called from here
	//ode_simulation();
	dSpaceCollide2( (dGeomID)space,(dGeomID)cameraSpace, NULL, &nearCallbackSpace );
//	dWorldStep( world, 0.05 );		//dWorldStep( world, 0.05 );
//    dJointGroupEmpty( contactJointGroup );
	if(isCollision!=36) collision=isCollision;
	
	return collision;
}

void ode_init()
{
 dInitODE2(0);
 world = dWorldCreate();
 space = dHashSpaceCreate(0);

 robotSpace = dHashSpaceCreate( space );
 dSpaceSetCleanup(robotSpace,0);
 staticSpace = dHashSpaceCreate( space );
 dSpaceSetCleanup(staticSpace,0);
 cameraSpace = dHashSpaceCreate (space );
 dSpaceSetCleanup(cameraSpace,0);

 contactJointGroup = dJointGroupCreate( 0 );
 
 dWorldSetGravity( world, 0, 0, 0 );
 ground = dCreatePlane(staticSpace, 0, 0, 1, 0);
 dWorldSetAutoDisableFlag (world,1);
 dWorldSetContactSurfaceLayer (world,0.001);
}

void ode_creation()
{
 
// groundGeom = dCreatePlane( staticSpace, 0, 1, 0, 0 );
  
  robot = new Robot(world);
  robot->setPosition(0,0,0);
  robot->addToSpace(robotSpace);

  camera = new Camera(world,camera_h/100,camera_w/100,camera_d/100);
  //camera->setPosition(robot,1,-2,1);
  camera->addToSpace(cameraSpace);
 
  addProcessEquipment(world,2.6,0,0);


}



void ode_simulation()
{	
//	robot->setTorque(-0.05);
//	const dReal *endPos = robot->getEndPos();
//	robot->moveArm(endPos[0],endPos[1]+0.1,endPos[2]-0.1);
    dSpaceCollide( space, NULL, &nearCallback );
    dWorldStep( world, 0.05 );		//dWorldStep( world, 0.05 );
    dJointGroupEmpty( contactJointGroup );
	
}

void ode_finalisation()
{
 
// dBodyDestroy( blackBaseBody );
 //dGeomDestroy( blackBaseGeom );
 //dGeomDestroy( groundGeom );
 //dJointGroupDestroy( robotJointGroup );
 dJointGroupDestroy( contactJointGroup );
 dSpaceDestroy( space );
 dWorldDestroy( world );
 dCloseODE();
}

int moveInitPos(dReal angle,Viewer *viewer)
{
	dReal endPos[3] = {valve1x,0,valve1h};
	robot->setTorque( 0.5);

	while(viewer->draw()){
		if(robot->getlink2JointAngle()>angle){
			robot->setTorque(0);

			return 1;
		}
		ode_simulation();
	}
	return 0;
}

void setCameraPos(Robot *robot,dReal x,dReal y,dReal z)
{
	camera->setPosition(robot,x,y,z);
}

void moveRobot(dReal endPos[3],Viewer *viewer,Camera *camera,Vbprm *vbprm, int path[], dReal avgdist[],dReal cameraAngle[])
{
	dReal tempPos[3];
	tempPos[0] = endPos[0]-0.4;
	tempPos[1] = endPos[1];
	tempPos[2] = endPos[2];
	robot->moveToPos(tempPos,viewer,camera,vbprm,path,avgdist,cameraAngle);
	robot->moveToPos(endPos,viewer,camera,vbprm,path,avgdist,cameraAngle);
}


int main()
{
 ode_init();
 //irrlicht_init();
 //irrlicht_creation();
 ode_creation();
 
 Viewer viewer(640*2,480);
 static Vbprm *vbprm = new Vbprm(0,0,0,2.6,0,0,camera,robot);
 

 //const dReal* cameraPosition = camera->getPosition();
 //camera->updatePosition(&viewer,cameraPosition[0],cameraPosition[1],cameraPosition[2]);
 //viewer.setVisibleDebug(processEquipment->getNode());
/*
ifstream positionFile ("posisjon.txt");

for(int i=0;i<3;i++){
	getline(positionFile,positionValve[i]);
}
positionFile.close();
 */

 /*
 //test
  dGeomID Geom1 = dCreateBox(space,0.2,0.2,0.2);
  dBodyID Body1 = dBodyCreate( world );
  dGeomSetBody(Geom1, Body1);
  
  ISceneNode* Node1 = viewer.getSceneManager()->addCubeSceneNode(1);
  dGeomSetData(Geom1, Node1);
  //dSpaceAdd(robotSpace, Geom1);
  const dReal *armEndPosition = robot->getEndPos();
  dBodySetPosition(Body1,armEndPosition[0],armEndPosition[1],armEndPosition[2]);

  dReal* position = (dReal*)dGeomGetPosition(Geom1);
  Node1->setPosition(vector3df((irr::f32)position[0], (irr::f32)position[1], (irr::f32)position[2]));
  Node1->setMaterialTexture(0, viewer.getVideoDriver()->getTexture("../../ode/drawstuff/textures/checkered.ppm"));
  Node1->setMaterialFlag(video::EMF_LIGHTING, false);
	
  viewer.addObject(Geom1);

 //test
*/
 //viewer.draw();
 readOperation();



 fillVbprm(vbprm,&viewer);
 
 
 robot->addToViewer(viewer);
 
 processEquipment->addToViewer(viewer);
 


 dReal endInitPos[3] = {1.5,0,1.5};
 dReal initCameraPos[3] = {1.5,0.2,1.5};
 setCameraPos(robot,initCameraPos[0],initCameraPos[1],initCameraPos[2]);
 int nodeNumber = 0;
 const dReal *nowPos;
 dReal newPos[3];
 dReal cameraPos[3];
 for(int i = 0;i<52*120*60;i++){
	 if( ((vbprm->G[i].V[0] - (initCameraPos[0])) < 0.025) && ((vbprm->G[i].V[0] - (initCameraPos[0]) > -0.025)) ){
		if( ((vbprm->G[i].V[1] - (initCameraPos[1]) < 0.025)) && ((vbprm->G[i].V[1] - (initCameraPos[1]) > -0.025)) ){
			if( ((vbprm->G[i].V[2] - (initCameraPos[2])) < 0.025) && ((vbprm->G[i].V[2] - (initCameraPos[2]) > -0.025)) ){
				nodeNumber = i;
				break;
			}
		}
	 }
 }

 //int nodeNumber = 120*(1+((endInitPos[1]+0.7)/0.05))+60*((endInitPos[2]-0.5)/0.05)+52*((endInitPos[0]-0.2)/0.05);
 vbprm->setCurrentNode(nodeNumber);
 cameraPos[0]= vbprm->G[nodeNumber].V[0];
 cameraPos[1]= vbprm->G[nodeNumber].V[1];
 cameraPos[2]= vbprm->G[nodeNumber].V[2];
 setCameraPos(robot,cameraPos[0],cameraPos[1],cameraPos[2]);
 camera->attachCameraJoint();
 positionErrorTip = 10;
 int inInitialPos = 0;
 
 robot->moveInitPos(endInitPos,positionErrorTip,&viewer);

 camera->addToViewer(viewer);
 viewer.setCameraViewParent(camera->getNode());
 //camera->setViewAngle(endInitPos);
 /*
 for(int i=0;i<2;i++)
	robot->moveToPos(positionValve1[i],&viewer,camera,vbprm);
	*/
int *path = new int[vbprm->numberOfSteps];
camera->createPath(vbprm,nodeNumber,positionValve,nodeNumber,path);
dReal cameraDist[3] = {9999,-1,0}; //min dist, maxdist, avg dist
dReal cameraAngle[3] = {3.14*2,0,0};
//setCameraPos(robot,endInitPos[0]-0.2,endInitPos[1]+0.7,endInitPos[2]-0.5);
camera->stepPosition = 0;

robot->moveToPos(tempPositions[0],&viewer,camera,vbprm,path,cameraDist,cameraAngle);


robot->moveToPos(tempPositions[1],&viewer,camera,vbprm,path,cameraDist,cameraAngle);


robot->moveToPos(tempPositions[2],&viewer,camera,vbprm,path,cameraDist,cameraAngle);



path[0];

 robot->moveToPos(positionValve,&viewer,camera,vbprm,path,cameraDist,cameraAngle);

 

 robot->setTorque(1);
 //camera->setPosition(robot,path[vbprm->numberOfSteps*3-3],path[vbprm->numberOfSteps*3-2],path[vbprm->numberOfSteps*3-1]);
 /*
 for(int i =0;i<3;i++)
	 robot->moveToPos(positionValve2[i],&viewer,camera,vbprm);
 robot->setTorque(0);
*/
 //robot->moveToPos(positionValve2[0],&viewer);
 
 while( viewer.draw() )
 {
  //irrlicht_render();
//	 if( !inInitialPos ) {
		//robot->moveArm(pathv1_x[initialPos],pathv1_y[initialPos],pathv1_z[initialPos]);
		//initialPos++;
//			posError = robot->moveInitPos(endInitPos,posError);
//		 posError = moveInitPos(posError,&viewer);
//		}
	 
  //robot->moveArm(position2[0],position2[1],position2[2]);
 
	 
  ode_simulation();
  
  //irrlicht_actualisation();
 }
 
 //irrlicht_finalisation();
 ode_finalisation();
 
 return 0;
}
	










