#include "vbprm.h"
#include <string.h>

dReal cameraStep = 0.05;
int xLen = 52; //2.6/0.05
int yLen = 120;
int zLen = 60;

Vbprm::Vbprm(dReal robotX, dReal robotY, dReal robotZ, dReal processX, dReal processY, dReal processZ, Camera *camera, Robot *robot)
{

	
	G = new prm[xLen*yLen*zLen];
	
	int counter = 0;
	for(dReal i=robotX;i<processX;i+=cameraStep){
		for (dReal n=robotY-3;n<robotY+3;n+=cameraStep){
			for(dReal k=0;k<3;k+=cameraStep){
				if (counter<(xLen*yLen*zLen)){
				G[counter].V[0] = i;
				G[counter].V[1] =n;
				G[counter].V[2] =k;
	
		//		camera->setPosition(robot, i,n,k);
				//G[counter].collision = camera->checkCollision();
				
				}
				counter++;

			}
		}
	}
	
	int node[3];
	for(int i = 0;i<xLen*yLen*zLen;i++){
		int nabo =0;
		for(int j=-2;j<3;j++){
			for(int h=-2;h<3;h++){
				for(int g=-2;g<3;g++){
					
					node[0] = G[i].V[0]+j*cameraStep;
					node[1] = G[i].V[1]+h*cameraStep;
					node[2] = G[i].V[2]+g*cameraStep;
					G[i].E[nabo] =(xLen*yLen*node[2]+xLen*node[1]+node[0])/cameraStep;// getNNode(node);
//					G[i].E[nabo]=yLen*(1+(G[i].V[1]+h*cameraStep)/cameraStep)+zLen*((G[i].V[2]+g*cameraStep)/cameraStep)+xLen*((G[i].V[0]+j*cameraStep)/cameraStep);
					nabo++;
				}
			}
		}
	}
	
/*
	for(int x=2;x<xLen-2;x++){
		for(int y=2;y<yLen-2;y++){
			for(int z=2;z<zLen-2;z++){
				int nabo =0;
	//			G[x*yLen+y*zLen+z*yLen*xLen].E = new int[5*5*5-1];
				for(int j=-2;j<3;j++){
					for(int h=-2;h<3;h++){
						for(int g=-2;g<3;g++){
							
							G[x*yLen+y*zLen+z*yLen*xLen].E[nabo]=(x+j*cameraStep)*yLen+(y+h*cameraStep)*zLen+(z+g*cameraStep)*yLen*xLen;
							nabo++;
						}
					}
				}
				
			}
		}
	}
	*/
}

dReal *Vbprm::getPoint(int point)
{
	return G[point].V;
}

void Vbprm::setCurrentNode(int n)
{
	currentNode = n;
}
int Vbprm::getCurrentNode()
{
	return currentNode;
}

int Vbprm::getNNode(int pos[])
{
 for(int i = 0;i<52*120*60;i++){
	 if( ((G[i].V[0] - (pos[0])) < 0.025) && ((G[i].V[0] - (pos[0]) > -0.025)) ){
		if( ((G[i].V[1] - (pos[1]) < 0.025)) && ((G[i].V[1] - (pos[1]) > -0.025)) ){
			if( ((G[i].V[2] - (pos[0])) < 0.025) && ((G[i].V[2] - (pos[2]) > -0.025)) ){
				
				return i;
			}
		}
	 }
 }
 return -1;
}

void Vbprm::setStatus(Robot *robot, Camera *camera,int stepNo, int nodeNo)
{
	const dReal *endPos = robot->getEndPos();
	dReal nodePos[3] = {G[nodeNo].V[0],G[nodeNo].V[1],G[nodeNo].V[2]};

	if( ((endPos[0]-nodePos[0])<0.5) && ((endPos[0]-nodePos[0])>0.0)){
		if( ((endPos[1]-nodePos[1])<-0.6) && ((endPos[1]-nodePos[1])>-1.0)){
			if( ((endPos[2]-nodePos[2])>-0.0) && ((endPos[2]-nodePos[2])<0.5)){
				camera->setPosition(robot, nodePos[0],nodePos[1],nodePos[2]);
				G[nodeNo].stepCollision[stepNo]=camera->checkCollision();
			}
		}
	}
	/*
	for(dReal i =endPos[0]-0.5;i<endPos[0]+0.2;i+=cameraStep){
		for(dReal j =endPos[1]-1;j<endPos[1]+1;j+=cameraStep){
			for(dReal k =endPos[2]-1;k<endPos[2]+1;k+=cameraStep){
				camera->setPosition(robot, i,j,k);
				G[nodeNo].stepCollision[stepNo]=camera->checkCollision();
			}
		}
	}
	*/
}